////////////////////////////////////////////////////////////////////

var video_mode = 7; // 800x600
var video_depth = 16; // 16 bit mode

var player_speed;
var enemy_speed;
var bullet1_speed;
var camera_distance = 250;

////////////////////////////////////////////////////////////////////

sound shoot1_snd = <shoot1.wav>;
sound beep_sound = <beep.wav>;

////////////////////////////////////////////////////////////////////

bmap health_map = <health.pcx>;

////////////////////////////////////////////////////////////////////

string shoot3rd_wmb = <shoot3rd.wmb>;

string soldiergun_mdl = <solgun.mdl>;
string enemy_mdl = <enemy.mdl>;
string enemygun_mdl = <enemygun.mdl>;
string bullet_mdl = <bullet.mdl>;

////////////////////////////////////////////////////////////////////

function move_enemy();
function enemy_damage();
function player_damage();
function init_shot();
function remove_bullet();
function attach_soldiergun();
function attach_enemygun();

////////////////////////////////////////////////////////////////////


panel health_pan 
{
	layer = 0;
	pos_x = 0;
	pos_y = 0;
	alpha = 50;
	vbar = 10, 10, 30, health_map, 1, player.skill20;
	flags = transparent, d3d, overlay, refresh, visible;
}

function main()
{
	level_load (shoot3rd_wmb);
	wait (2); // wait for the level to be loaded
	clip_size = 0; // show all the triangles for all the models
	fps_max = 50; // lock the frame rate to 50 fps
	on_d = null;
}

action player_init
{	
	player = me;
	player.skill20 = 100; // use skill20 to store player's health
	my.enable_impact = on;
	my.event = player_damage;
	camera.z = my.z + 150;
	camera.tilt = -25;
	ent_create(soldiergun_mdl, nullvector, attach_soldiergun); // give him a gun
	while (my.skill20 > 0) // still running :)
	{
		my.pan += 4 * (key_a - key_d) * time - 20 * mouse_force.x * time;
		player_speed.x = 10 * (key_w - key_s) * (1 - mouse_left) * time;
		player_speed.y = 0;

		if (mouse_left == 1) // fire with the left mouse button
		{
			ent_cycle ("attack", 100); // set the last "attack" frame
			wait (1); // make sure that the bullet will go in the right direction
			ent_create (bullet_mdl, my.skill12, init_shot);
			snd_play (shoot1_snd, 70, 0);
			//while (mouse_left == 1) {wait (1);}
			wait (1);
		}
		else
		{
			if (player_speed.x != 0) // the player is moving
			{
				ent_cycle ("walk", my.skill10); // play "walk" animation
				my.skill10 += 10 * time;
				if (my.skill10 > 100) {my.skill10 = 0;} // loop animation
			}
		}

		vec_set (temp, my.x);
		temp.z -= 3000;
		trace_mode = ignore_me + ignore_sprites + ignore_models + use_box;
		player_speed.z = -trace (my.x, temp);
		ent_move(player_speed, nullvector);

		camera.pan = my.pan;	
		camera.x = my.x - camera_distance * cos (my.pan);
		camera.y = my.y - camera_distance * sin (my.pan);

		wait (1);
	}
}

function attach_soldiergun()
{
	proc_late();
	my.passable = on;
	my.metal = on;
	while(you != null)
	{
		vec_set(my.x,you.x);
	   	vec_set(my.pan,you.pan);
   		my.frame = you.frame;
	   	my.next_frame = you.next_frame;
		vec_for_vertex(you.skill12, my, 6); // soldier's bullet position is stored in soldier's skill12
   		wait(1);
	}
	ent_remove(my);
}

function init_shot()
{
	my.pan = you.pan;
	my.tilt = you.tilt;
	my.skill10 = 1; // this is a bullet fired by the soldier
	my.enable_entity = on;
	my.enable_block = on;
	my.event = remove_bullet;
	my.ambient = 100;
	my.skill1 = 0;
	bullet1_speed.x = 10;
	bullet1_speed.y = 0;
	bullet1_speed.z = 0;
	bullet1_speed *= time;
	while ((my != null) && (my.skill1 < 500)) // 500 = max distance
	{
		my.skill1 += 1 * time;
		move_mode = ignore_you + ignore_passents;
		ent_move (bullet1_speed, nullvector);
		wait (1);
	}
	ent_remove (me);
}

action generate_enemy
{
	my.scale_x *= 0.7;
	my.scale_y = my.scale_x;
//	my.invisible = on; // remove the comment to hide the enemy generators
	my.passable = on;
	my.oriented = on;
	my.bright = on;
	my.flare = on;
	while (player == null) {wait (1);}
	while (vec_dist (my.x, player.x) < 500) {wait (1);}
	waitt (48 + random (64)); // wait 3..7 seconds
	vec_set (temp, my.pos);
	temp.z += 50;
	ent_create (enemy_mdl, my.pos, move_enemy);
}

function attach_enemygun()
{
	proc_late();
	my.passable = on;
	my.metal = on;
	while(you != null)
	{
		vec_set(my.x,you.x);
	   	vec_set(my.pan,you.pan);
   		my.frame = you.frame;
	   	my.next_frame = you.next_frame;
		vec_for_vertex(you.skill12, my, 148); // enemy's bullet position is stored in enemy's skill12
   		wait(1);
	}
	ent_remove(my);
}

function move_enemy
{
	my.enable_impact = on;
	my.event = enemy_damage;
	ent_create(enemygun_mdl, nullvector, attach_enemygun); // give him a gun
	while (vec_dist(my.x, player.x) > (300 + random(100)))
	{
		enemy_speed.x = 10 * time;
		enemy_speed.y = 0;
		enemy_speed.z = 0;

		vec_set (temp.x, player.x); // rotate towards the player
		vec_sub (temp.x, my.x);
		vec_to_angle (my.pan, temp);

		move_mode = ignore_you + ignore_passents;
		ent_move (enemy_speed, nullvector);
		ent_cycle ("walk", my.skill10); // play walk frames animation
		my.skill10 += 10 * time;
		if (my.skill10 > 100) {my.skill10 = 0;} // loop animation
		my.tilt = 0; 
		wait (1);
	}
	ent_cycle("attack", 100);
	waitt (2);
	while (my.skill30 == 0 && player.skill20 > 0) // as long as the enemy and the player are alive
	{
		vec_set (temp.x, player.x);
		vec_sub (temp.x, my.skill12);
		vec_to_angle (my.pan, temp);
		ent_create (bullet_mdl, my.skill12, init_shot);
		my.tilt = 0;
		snd_play (shoot1_snd, 70, 0);
		waitt (32); // the enemy shoots a bullet every 2 seconds
	}
}

function player_damage()
{
	if (you.skill10 != 1) 
	{
		return; // it wasn't hit by a bullet
	} 
	else // hit by an enemy bullet
	{
		my.skill20 -= 10; // decrease player's health (10 points)
		if (my.skill20 <= 0) // if the player is dead
		{
			my.enable_impact = off;
			my.event = null;
			my.skill10 = 0; // start with the first death frame
			my.skill30 = 1; // I'm dead	
			while (my.skill10 < 67)
			{	
				ent_cycle("death", my.skill10); // play death animation
				my.skill10 += 6 * time;

				if (camera.z > player.z + 300) 
				{
					camera.z -= 10 * time; // zoom in to see player dead
				}
				wait (1);
			}
			
		}
	}
}

function enemy_damage()
{
	if (you.skill10 != 1) {return;} // it wasn't hit by a bullet
	wait (1);
	my.enable_impact = off;
	my.event = null;
	my.skill10 = 0; // start with the first death frame
	my.skill30 = 1; // I'm dead	
	while (my.skill10 < 67)
	{	
		ent_cycle("death", my.skill10); // play death animation
		my.skill10 += 6 * time;
		wait (1);
	}
	my.passable = on; // can pass through the corpse
}

function remove_bullet()
{
	wait (1);
	ent_remove (me);
}